VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ComDlgEx"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'This source code is copyrighted material which
'may not be published in any form without explicit prior permission
'from the author. However, you are free to use the source code
'in your private, non-commercial, projects without permission.
'You are allowed to use these functions and routines in commercial
'products, provided the documentation of these products makes a
'reference to the original source. The following reference is recommended:
'-----------------------------------------------------------
'(PART OF) THIS SOFTWARE IS BASED ON SOURCE CODE, ORIGINALLY CREATED
'BY ROMKE SOLDAAT (ROMKE@SOLDAAT.COM), AND PUBLISHED IN MICROSOFT
'OFFICE & VISUAL BASIC FOR APPLICATIONS DEVELOPER, BY INFORMANT
'COMMUNICATIONS GROUP (WWW.INFORMANT.COM)
'-----------------------------------------------------------

Option Explicit
DefStr S
DefLng L, N
DefBool B
DefVar V

Private Type OSVERSIONINFO
  dwOSVersionInfoSize As Long
  dwMajorVersion As Long
  dwMinorVersion As Long
  dwBuildNumber As Long
  dwPlatformId As Long
  szCSDVersion As String * 128
End Type

' OFN constants
Const OFN_ALLOWMULTISELECT = &H200
Const OFN_CREATEPROMPT = &H2000
Const OFN_ENABLEHOOK = &H20
Const OFN_ENABLETEMPLATE = &H40
Const OFN_EXPLORER = &H80000
Const OFN_EXTENSIONDIFFERENT = &H400
Const OFN_FILEMUSTEXIST = &H1000
Const OFN_HIDEREADONLY = &H4
Const OFN_LONGNAMES = &H200000
Const OFN_NOCHANGEDIR = &H8
Const OFN_NODEREFERENCELINKS = &H100000
Const OFN_OVERWRITEPROMPT = &H2
Const OFN_PATHMUSTEXIST = &H800
Const OFN_READONLY = &H1
Const OFN_SHOWHELP = &H10
Const OFN_ENABLESIZING = &H800000
Const CDERR_FINDRESFAILURE = &H6
Const CDERR_NOHINSTANCE = &H4
Const CDERR_NOTEMPLATE = &H3

'String constants:
Const sBackSlash As String = "\"
Const sPipe As String = "|"

'Type declaration, used by the common dialogs
Private Type OPENFILENAME
  lStructSize       As Long
  hwndOwner         As Long
  hInstance         As Long
  lpstrFilter       As String
  lpstrCustomFilter As String
  nMaxCustFilter    As Long
  nFilterIndex      As Long
  lpstrFile         As String
  nMaxFile          As Long
  lpstrFileTitle    As String
  nMaxFileTitle     As Long
  lpstrInitialDir   As String
  lpstrTitle        As String
  Flags             As Long
  nFileOffset       As Integer
  nFileExtension    As Integer
  lpstrDefExt       As String
  lCustData         As Long
  lpfnHook          As Long
  lpTemplateID      As Long
End Type

' private variables:
Private OFN As OPENFILENAME
Private colFileTitles As New Collection
Private colFileNames As New Collection
Private sFullName
Private sFileTitle
Private sPath
Private sExtension
Private nCenter
Private nHide
Private bStatusbarVisible
Private bCenterDialog
Private sOKCaption
Private sCancelCaption
Private sHelpCaption
Private sBtn1Caption
Private sBtn2Caption
Private sBtn3Caption
Private sBtn4Caption
Private sBtn5Caption
Private sLookInCaption
Private sFileNameCaption
Private sFileTypeCaption
Private sReadOnlyCaption
Private sHelpText
Private sIconFile
Private nIconIndex
Private sTemplateLib
Private nTemplateID
'=================================

'API functions to use the Windows common dialog boxes
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias _
  "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias _
  "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetActiveWindow Lib "user32" () As Long

Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" ( _
  ByVal lpLibFileName As String) As Long
Private Declare Function FreeLibrary Lib "kernel32" ( _
  ByVal hLibModule As Long) As Long
Private Declare Function CommDlgExtendedError Lib "comdlg32.dll" () As Long
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" ( _
  lpVersionInformation As OSVERSIONINFO) As Long
Private Declare Function ReleaseDC Lib "user32" ( _
  ByVal hwnd As Long, ByVal hDc As Long) As Long

Public Enum XFlags
  PathMustExist = OFN_PATHMUSTEXIST
  FileMustExist = OFN_FILEMUSTEXIST
  PromptToCreateFile = OFN_CREATEPROMPT
End Enum

Public Enum HideFlags
  HideLookInListbox = 1
  HideFileNameTextbox = 2
  HideFileTypeListbox = 4
End Enum

Public Enum CenterOptions
  DontCenter
  CenterOwner
  CenterScreen
End Enum

Property Let AllowMultiSelect(bFlag)
SetFlag OFN_ALLOWMULTISELECT, bFlag
End Property

Property Get AllowMultiSelect() As Boolean
AllowMultiSelect = OFN.Flags And OFN_ALLOWMULTISELECT
End Property

Property Let DialogTitle(sCaption)
OFN.lpstrTitle = sCaption
End Property

Property Let Filter(vFilter)
If IsArray(vFilter) Then vFilter = Join(vFilter, vbNullChar)
OFN.lpstrFilter = Replace(vFilter, sPipe, vbNullChar) & vbNullChar
End Property

Property Get Filter()
With OFN
  If .nFilterIndex Then
    Dim sTemp()
    sTemp = Split(.lpstrFilter, vbNullChar)
    Filter = sTemp(.nFilterIndex * 2 - 2) & sPipe & sTemp(.nFilterIndex * 2 - 1)
  End If
End With
End Property

Property Let FilterIndex(nIndex)
OFN.nFilterIndex = nIndex
End Property

Property Get FilterIndex() As Long
FilterIndex = OFN.nFilterIndex
End Property

Property Let RestoreCurDir(bFlag)
SetFlag OFN_NOCHANGEDIR, bFlag
End Property

Property Let ExistFlags(nFlags As XFlags)
OFN.Flags = OFN.Flags Or nFlags
End Property

Property Let CheckBoxVisible(bFlag)
SetFlag OFN_HIDEREADONLY, Not bFlag
End Property

Property Get CheckBoxVisible() As Boolean
CheckBoxVisible = (OFN.Flags And OFN_HIDEREADONLY) = False
End Property

Property Let CheckBoxSelected(bFlag)
SetFlag OFN_READONLY, bFlag
End Property

Property Get CheckBoxSelected() As Boolean
CheckBoxSelected = OFN.Flags And OFN_READONLY
End Property

Property Let FileName(SFilename)
If Len(SFilename) <= MAX_PATH Then OFN.lpstrFile = SFilename
End Property

Property Get FileName() As String
FileName = sFullName
End Property

Property Get FileNames() As Collection
Set FileNames = colFileNames
End Property

Property Get FileTitle() As String
FileTitle = sFileTitle
End Property

Property Get FileTitles() As Collection
Set FileTitles = colFileTitles
End Property

Property Let Directory(sInitDir)
OFN.lpstrInitialDir = sInitDir
End Property

Property Get Directory() As String
Directory = sPath
End Property

Property Let Extension(sDefExt)
OFN.lpstrDefExt = LCase$(Left$(Replace(sDefExt, ".", vbNullString), 3))
End Property

Property Get Extension() As String
Extension = sExtension
End Property

Property Let CheckBoxCaption(sCaption)
sReadOnlyCaption = sCaption
If Len(sCaption) Then SetFlag OFN_HIDEREADONLY, False
End Property

Property Get CheckBoxCaption() As String
CheckBoxCaption = sReadOnlyCaption
End Property

Property Let StatusbarVisible(bFlag)
bStatusbarVisible = bFlag
End Property

Property Get StatusbarVisible() As Boolean
StatusbarVisible = bStatusbarVisible
End Property

Property Let CenterDialog(nValue As CenterOptions)
nCenter = nValue
End Property

Property Get CenterDialog() As CenterOptions
CenterDialog = nCenter
End Property

Property Let HideControls(nValue As HideFlags)
nHide = nValue
End Property

Property Get HideControls() As HideFlags
HideControls = nHide
End Property

Property Let txtButton1(sCaption)
sBtn1Caption = sCaption
End Property

Property Get txtButton1() As String
txtButton1 = sBtn1Caption
End Property

Property Let txtButton2(sCaption)
sBtn2Caption = sCaption
End Property

Property Get txtButton2() As String
txtButton2 = sBtn2Caption
End Property

Property Let txtButton3(sCaption)
sBtn3Caption = sCaption
End Property

Property Get txtButton3() As String
txtButton3 = sBtn3Caption
End Property

Property Let txtButton4(sCaption)
sBtn4Caption = sCaption
End Property

Property Get txtButton4() As String
txtButton4 = sBtn4Caption
End Property

Property Let txtButton5(sCaption)
sBtn5Caption = sCaption
End Property

Property Get txtButton5() As String
txtButton5 = sBtn5Caption
End Property

Property Let txtButtonOK(sCaption)
sOKCaption = sCaption
End Property

Property Get txtButtonOK() As String
txtButtonOK = sOKCaption
End Property

Property Let txtButtonCancel(sCaption)
sCancelCaption = sCaption
End Property

Property Get txtButtonCancel() As String
txtButtonCancel = sCancelCaption
End Property

Property Let txtButtonHelp(sCaption)
sHelpCaption = sCaption
End Property

Property Get txtButtonHelp() As String
txtButtonHelp = sHelpCaption
End Property

Property Let txtLabelLookIn(sCaption)
sLookInCaption = sCaption
End Property

Property Get txtLabelLookIn() As String
txtLabelLookIn = sLookInCaption
End Property

Property Let txtLabelFileName(sCaption)
sFileNameCaption = sCaption
End Property

Property Get txtLabelFileName() As String
txtLabelFileName = sFileNameCaption
End Property

Property Let txtLabelFileType(sCaption)
sFileTypeCaption = sCaption
End Property

Property Get txtLabelFileType() As String
txtLabelFileType = sFileTypeCaption
End Property

Property Let HelpMessage(sHelp)
sHelpText = sHelp
SetFlag OFN_SHOWHELP, True
End Property

Property Get HelpMessage() As String
HelpMessage = sHelpText
End Property

Property Let IconFile(sFile)
sIconFile = sFile
End Property

Property Get IconFile() As String
IconFile = sIconFile
End Property

Property Let IconIndex(nIndex)
nIconIndex = nIndex
End Property

Property Get IconIndex() As Long
IconIndex = nIconIndex
End Property

Property Let TemplateLibrary(sLib)
sTemplateLib = sLib
End Property

Property Let TemplateID(nID)
nTemplateID = nID
End Property

Function ShowOpen() As Boolean
ShowOpen = Show(True)
End Function

Function ShowSave() As Boolean
' Set or clear the appropriate flags for the Save As dialog:
SetFlag OFN_ALLOWMULTISELECT, False
SetFlag OFN_PATHMUSTEXIST, True
SetFlag OFN_OVERWRITEPROMPT, True
ShowSave = Show(False)
End Function

Function Show(bOpen) As Boolean
On Error Resume Next
With OFN
  .lStructSize = Len(OFN)
  .hwndOwner = GetActiveWindow  ' could be zero if no owner is required
  ' If the RO checkbox must be checked, we should also display it:
  If .Flags And OFN_READONLY Then SetFlag OFN_HIDEREADONLY, False
  .nMaxFile = IIf(.Flags And OFN_ALLOWMULTISELECT, _
    MAX_BUFFER + 1, MAX_PATH + 1)
  .nMaxFileTitle = MAX_PATH + 1
  ' Initialize the buffers:
  .lpstrFile = .lpstrFile & String$(.nMaxFile - 1 - Len(.lpstrFile), 0)
  .lpstrFileTitle = String(.nMaxFileTitle - 1, 0)
  
  If Len(sTemplateLib) Then
    SetFlag OFN_ENABLETEMPLATE, True
    .hInstance = LoadLibrary(sTemplateLib)
    .lpTemplateID = nTemplateID
    If .hInstance = 0 Then
      SetFlag OFN_ENABLETEMPLATE, False
    End If
  End If
  
  .lpfnHook = GetProc(AddressOf OFNHookProc)
  
ContinueWithoutTemplate:
  If bOpen Then
    Show = GetOpenFileName(OFN)
  Else
    Show = GetSaveFileName(OFN)
  End If
  
  Select Case CommDlgExtendedError
  Case CDERR_NOTEMPLATE, CDERR_FINDRESFAILURE, CDERR_NOHINSTANCE
    MsgBox "Template Library or Template ID not found." & vbCr & _
      "Continuing without Template..."
    .Flags = .Flags And Not OFN_ENABLETEMPLATE
    GoTo ContinueWithoutTemplate
  Case Else: End Select
  
  If Show Then
    Dim nDoubleNullPos
    'Remove trailing null characters:
    nDoubleNullPos = InStr(.lpstrFile & vbNullChar, String$(2, 0))
    If nDoubleNullPos Then
      ' Get the file name including the path name:
      sFullName = Left$(.lpstrFile, nDoubleNullPos - 1)
      ' Get the file name without the path name:
      sFileTitle = Left$(.lpstrFileTitle, InStr(.lpstrFileTitle, vbNullChar) - 1)
      ' Get the path name:
      sPath = Left$(sFullName, .nFileOffset - 1)
      ' Get the extension:
      If .nFileExtension Then
        sExtension = Mid$(sFullName, .nFileExtension + 1)
      End If
      'if sFileTitle is a string, we have a single selection:
      If Len(sFileTitle) Then
        colFileTitles.Add Mid$(sFullName, .nFileOffset + 1)
        colFileNames.Add sFullName
      Else  'tear multiple selection apart
        Dim sTemp(), nCount
        sTemp = Split(sFullName, vbNullChar)
        'if array contains no elements, UBound returns -1
        If UBound(sTemp) > LBound(sTemp) Then
          'we have more than one array element!
          'remove backslash if sPath is the root folder:
          If Len(sPath) = 3 Then sPath = Left$(sPath, 2)
          ' loop through the array, and create the collections;
          ' we skip the first element (which contains the path name),
          ' so we start the counter at 1, not at 0
          For nCount = 1 To UBound(sTemp)
            colFileTitles.Add sTemp(nCount)
            'if the string already contains a backslash, the user
            'must have selected a shortcut file, so we don't add
            'the path
            colFileNames.Add IIf(InStr(sTemp(nCount), sBackSlash), _
              sTemp(nCount), sPath & sBackSlash & sTemp(nCount))
          Next
          ' clear this variable:
          sFullName = vbNullString
        End If
      End If
        'add backslash if sPath is the root folder:
      If Len(sPath) = 2 Then sPath = sPath & sBackSlash
    End If
  End If
  FreeLibrary .hInstance
End With

Call ReleaseDC(hwndStatus, hDc)
Call DestroyIcon(hIconCaption)
Call DestroyIcon(hIconStatusbar)
Call DestroyWindow(hwndStatus)

End Function

Private Sub Class_Initialize()
' this routine runs when the object is created
OFN.Flags = OFN.Flags Or OFN_EXPLORER Or OFN_LONGNAMES Or OFN_HIDEREADONLY Or OFN_ENABLEHOOK 'Or OFN_ENABLESIZING
Set CurDialog = Me
Const VER_PLATFORM_WIN32_NT = 2
Dim OVI As OSVERSIONINFO
OVI.dwOSVersionInfoSize = Len(OVI)
Call GetVersionEx(OVI)
IsWinNT = OVI.dwPlatformId And VER_PLATFORM_WIN32_NT
End Sub

Private Sub SetFlag(nValue, bTrue)
With OFN
  If bTrue Then
    .Flags = .Flags Or nValue
  Else
    .Flags = .Flags And Not nValue
  End If
End With
End Sub

Private Function GetProc(lProc As Long) As Long
  GetProc = lProc
End Function

