Attribute VB_Name = "ComDlgHook"
'This source code is copyrighted material which
'may not be published in any form without explicit prior permission
'from the author. However, you are free to use the source code
'in your private, non-commercial, projects without permission.
'You are allowed to use these functions and routines in commercial
'products, provided the documentation of these products makes a
'reference to the original source. The following reference is recommended:
'-----------------------------------------------------------
'(PART OF) THIS SOFTWARE IS BASED ON SOURCE CODE, ORIGINALLY CREATED
'BY ROMKE SOLDAAT (ROMKE@SOLDAAT.COM), AND PUBLISHED IN MICROSOFT
'OFFICE & VISUAL BASIC FOR APPLICATIONS DEVELOPER, BY INFORMANT
'COMMUNICATIONS GROUP (WWW.INFORMANT.COM)
'-----------------------------------------------------------

Option Explicit
DefStr S
DefLng H, N
DefBool B
DefVar V

'these two public variables are set in Class_Initialize:
Public CurDialog As Object, IsWinNT As Boolean

Public hwndStatus, hIconCaption, hIconStatusbar, hDc

'private variables:
Private hwndDlg, n3Panes(2), n2Panes(1), n1Panes(0), nPanes()

'The maximum string length of a single file path:
Public Const MAX_PATH = 260
'This MAX_BUFFER value allows you to select approx.
'500 files with an average length of 25 characters.
'Change this value as needed.
Public Const MAX_BUFFER = 50 * MAX_PATH   '13,000
Private BUFF_SIZE As Long

Const KB = 1024                   '1 kilobyte
Const MB = 1048576                '1 megabyte
Const sQuote = """"               'Chr(34)
Const sSpace = " "                'Chr(32)

Const WM_USER = &H400             'Offset for many other constants

'msgs sent to the Open/Save dlg's callback function:
Const WM_INITDIALOG = &H110       'Dialog is being initialized
Const WM_NOTIFY = &H4E            'Msg sent by common dialog
Const WM_COMMAND = &H111          'A dlg box control has been clicked
Const WM_SETTEXT = &HC
Const CDN_INITDONE = -601         'Initialization is finished
Const CDN_SELCHANGE = -602        'Selection changed in folder/file list
Const CDN_FOLDERCHANGE = -603     'New folder is opened
Const CDN_TYPECHANGE = -607       'New file type selected
Const CDN_SHAREVIOLATION = -604   'Share violationhas occurred
Const CDN_HELP = -605             'Help button is clicked
Const CDN_FILEOK = -606           'OK button is clicked after file selection

'Common dlg msgs:
Const CDM_FIRST = (WM_USER + 100)             'offset value
Const CDM_GETSPEC = (CDM_FIRST + &H0)         'get name of selected file
Const CDM_GETFILEPATH = (CDM_FIRST + &H1)     'get path and name of selected file
Const CDM_GETFOLDERPATH = (CDM_FIRST + &H2)   'get path of current folder
Const CDM_GETFOLDERIDLIST = (CDM_FIRST + &H3) 'get address of item identifier list
Const CDM_SETCONTROLTEXT = (CDM_FIRST + &H4)  'set text for specified control
Const CDM_HIDECONTROL = (CDM_FIRST + &H5)     'hides specified control
Const CDM_SETDEFEXT = (CDM_FIRST + &H6)       'set default file name extension

'Common dlg controls (buttons, listboxes, labels)
'These values are documented in the Windows SDK
Const ID_OK = 1
Const ID_CANCEL = 2
Const ID_HELP = &H40E
Const ID_FILENAMETEXT = &H442
Const ID_FILENAMEEDIT = &H480
Const ID_LOOKINTEXT = &H443
Const ID_LOOKINLIST = &H471
Const ID_FILELIST = &H460
Const ID_CHECKBOX = &H410
Const ID_FILEOFTYPETEXT = &H441
Const ID_FILEOFTYPELIST = &H470

'Template control IDs:
Const ID_BUTTON_OFFSET = 100
Const ID_BUTTON_1 = 101
Const ID_BUTTON_2 = 102
Const ID_BUTTON_3 = 103
Const ID_BUTTON_4 = 104
Const ID_BUTTON_5 = 105

'msg sent to statusbar:
Const SB_SETICON = (WM_USER + 15) 'Set statusbar icon
Const SB_SETPARTS = (WM_USER + 4)
Const SB_SIMPLE = (WM_USER + 9)
Const SB_SETTEXTA = (WM_USER + 1)   'ANSI version
Const SB_SETTEXTW = (WM_USER + 11)  'Unicode version

'SetWindowPos constants:
Const HWND_TOP = 0                'Place window at the top of the Z order
Const SWP_NOSIZE = &H1            'Don't change window size
Const SWP_NOMOVE = &H2            'Don't move window

'SHGetFileInfo constants:
Const SHGFI_ICON = &H100
Const SHGFI_SMALLICON = &H1
Const SHGFI_OPENICON = &H2
Const SHGFI_SHELLICONSIZE = &H4
Const SHGFI_USEFILEATTRIBUTES = &H10
'private derived constants:
Const VALID_PATH_ICON = _
  SHGFI_ICON Or SHGFI_SMALLICON Or _
  SHGFI_OPENICON Or SHGFI_SHELLICONSIZE
Const INVALID_PATH_ICON = _
  SHGFI_ICON Or SHGFI_SMALLICON Or _
  SHGFI_USEFILEATTRIBUTES Or SHGFI_SHELLICONSIZE

'Structures

'NMHDR is sent with WM_NOTIFY msg
Type NMHDR
  hwndFrom As Long
  idfrom As Long
  code As Long    'code is one of the messages starting with CDN_
End Type

'RECT is used with GetWindowRect; returns window coordinates
Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type
   
'POINTAPI is used with ScreenToClient; returns window coordinates
Private Type POINTAPI
  x As Long
  y As Long
End Type

'SHFILEINFO is used with SHGetFileInfo; returns file info
Public Type SHFILEINFO
  hIcon As Long                       'icon handle
  iIcon As Long                       'icon index in image list
  dwAttributes As Long                'file attributes
  szDisplayName As String * MAX_PATH  '(icon) file name
  szTypeName As String * 80           'file type description
End Type

Dim NMH As NMHDR
Dim SFI As SHFILEINFO

'Windows functions:

Private Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoA" ( _
  ByVal pszPath As String, ByVal dwFileAttributes As Long, _
  psfi As SHFILEINFO, ByVal cbFileInfo As Long, ByVal uFlags As Long) As Long
  
Private Declare Function CreateStatusWindow Lib "comctl32" ( _
  ByVal dwExStyle As Long, ByVal lpszText As String, _
  ByVal hwndParent As Long, ByVal wID As Long) As Long

Public Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long

Private Declare Function ExtractIcon Lib "shell32.dll" Alias "ExtractIconA" ( _
  ByVal hInst As Long, ByVal lpszExeFileName As String, ByVal nIconIndex As Long) As Long
  
Public Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
  hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
  
Private Declare Function WinMsgBox Lib "user32" Alias "MessageBoxA" ( _
  ByVal hwnd As Long, ByVal lpText As String, _
  ByVal lpCaption As String, ByVal wType As Long) As Long
  
Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long

Private Declare Function GetWindowRect Lib "user32" _
  (ByVal hwnd As Long, lpRect As RECT) As Long

Private Declare Function GetDesktopWindow Lib "user32" () As Long

Private Declare Function SetWindowPos Lib "user32" ( _
  ByVal hwnd As Long, ByVal hWndInsertAfter As Long, _
  ByVal x As Long, ByVal y As Long, ByVal cx As Long, _
  ByVal cy As Long, ByVal wFlags As Long) As Long

Private Declare Function ShowWindow Lib "user32" ( _
  ByVal hwnd As Long, ByVal nCmdShow As Long) As Long

Private Declare Function SetWindowText Lib "user32" _
   Alias "SetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String) As Long

Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" ( _
  ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long

Private Declare Function SendMessage Lib "user32" _
   Alias "SendMessageA" (ByVal hwnd As Long, _
   ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
   
Private Declare Function GetDlgItem Lib "user32" ( _
  ByVal hDlg As Long, ByVal nIDDlgItem As Long) As Long
  
Private Declare Function PathCompactPath Lib "ShlWAPI" Alias _
  "PathCompactPathA" (ByVal hDc As Long, ByVal lpszPath As String, _
  ByVal dx As Long) As Long
        
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long

Private Declare Function MoveWindow Lib "user32" ( _
  ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, _
  ByVal nWidth As Long, ByVal nHeight As Long, _
  ByVal bRepaint As Long) As Long
  
Private Declare Function ScreenToClient Lib "user32" ( _
  ByVal hwnd As Long, lpPoint As POINTAPI) As Long

Public Function OFNHookProc( _
  ByVal hwnd As Long, ByVal uMsg As Long, _
  ByVal wParam As Long, ByVal lParam As Long) As Long
  
On Error Resume Next
hwndDlg = GetParent(hwnd)
If hwndDlg = 0 Then Exit Function
Dim sBuff, nNullPos, n
            
Select Case uMsg
  Case WM_COMMAND  'one of the template controls is clicked
    'lParam is the control's window handle
    'The low-order word of wParam contains the control's ID
    'The following instructions are only intended to demonstrate
    'how you can use these values
    'These routines obtain the names of the selected files, and
    'display them in a message box:
   
     Dim sPath, sMsg
     BUFF_SIZE = IIf(CurDialog.AllowMultiSelect, MAX_BUFFER, MAX_PATH)
     sBuff = String$(BUFF_SIZE, 0)
     nNullPos = SendMessage(hwndDlg, CDM_GETSPEC, BUFF_SIZE, ByVal sBuff)
     sBuff = Left$(sBuff, nNullPos - 1)
     sPath = CurDir
     If Right$(sPath, 1) <> "\" Then sPath = sPath & "\"
     If nNullPos = 1 Then
       sMsg = "no files selected"
     ElseIf InStr(sBuff, sQuote) Then
       sBuff = Replace(sBuff, sQuote & sSpace & sQuote, sQuote)
       Dim sTemp(): sTemp = Split(sBuff, sQuote)
       For n = LBound(sTemp) To UBound(sTemp) - 1
         sMsg = sMsg & sPath & sTemp(n) & vbCr
       Next
     Else
       sMsg = sPath & sBuff
     End If
     'ShowMessage sMsg, "You clicked " & GetCaption(lParam)
     
     Select Case LowWord(wParam)
     Case ID_BUTTON_1
       'code to run in response to clicking this button
            MsgBox "Put Copy File code here"
     Case ID_BUTTON_2
       'code to run in response to clicking this button
            MsgBox "Put Move File code here"

     Case ID_BUTTON_3
       'code to run in response to clicking this button
            MsgBox "Put Delete File code here"

     Case ID_BUTTON_4
       'code to run in response to clicking this button
            MsgBox "Put Print File code here"

     Case ID_BUTTON_5
       'code to run in response to clicking this button
            MsgBox "Put in the About Box code here"

     Case Else: End Select

  Case WM_NOTIFY
   'The WM_NOTIFY message contains the OFNOTIFY structure in lParam.
   'OFNOTIFY contains a pointers to an NMHDR structure.
   
   'Get the NMHDR structure from the pointer
    CopyMemory NMH, ByVal lParam, LenB(NMH)
   'The code value of NMHDR contains the actual message:
    Select Case NMH.code
      
    Case CDN_INITDONE 'all customizations are done
      With CurDialog
        If .StatusbarVisible Then CreateStatusbar
        Select Case .CenterDialog
        Case 1: CenterChildWindow GetParent(hwndDlg), hwndDlg
        Case 2: CenterChildWindow GetDesktopWindow, hwndDlg
        Case Else: End Select
      End With
       
    Case CDN_FOLDERCHANGE 'when a new folder is opened
      If CurDialog.StatusbarVisible = True Then
        sBuff = String$(MAX_PATH, 0)
        nNullPos = SendMessage(hwndDlg, CDM_GETFOLDERPATH, MAX_PATH, ByVal sBuff)
        If nNullPos = -1 Then  'error
          UpdateStatusbar INVALID_PATH_ICON, 1, "(No folder selected)"
        Else
          UpdateStatusbar VALID_PATH_ICON, 1, Left$(sBuff, nNullPos - 1)
        End If
      End If
      
    Case CDN_SELCHANGE 'when the selection changes in the file list box
      If CurDialog.StatusbarVisible = True Then
        BUFF_SIZE = IIf(CurDialog.AllowMultiSelect, MAX_BUFFER, MAX_PATH)
        sBuff = String$(BUFF_SIZE, 0)
        nNullPos = SendMessage(hwndDlg, CDM_GETSPEC, BUFF_SIZE, ByVal sBuff)
        sBuff = Left$(sBuff, nNullPos - 1)
        If InStr(sBuff, sQuote) Then
          UpdateStatusbar VALID_PATH_ICON, 2, CurDir, _
            CStr(UBound(Split(sBuff, sQuote)) / 2) & " files selected"
        Else
          UpdateStatusbar VALID_PATH_ICON, 3, sBuff, _
            TranslateFileSize(FileLen(sBuff)), _
            TranslateFileDate(FileDateTime(sBuff))
        End If
      End If
      
    Case CDN_HELP
      With CurDialog
        ShowMessage .HelpMessage, _
          Replace(GetCaption(GetDlgItem(hwndDlg, ID_HELP)), "&", vbNullString)
      End With
      
    'the following 3 messages are not processed:
    Case CDN_TYPECHANGE
    Case CDN_SHAREVIOLATION
    Case CDN_FILEOK
      
    Case Else: End Select

  Case WM_INITDIALOG
      
    With CurDialog
    
      If Len(.IconFile) Then SetTitlebarIcon .IconFile, .IconIndex
      
      StretchDefaultControls
      
      'set captions for common dialog controls:
      SetCaption ID_OK, .txtButtonOK
      SetCaption ID_CANCEL, .txtButtonCancel
      SetCaption ID_HELP, .txtButtonHelp
      SetCaption ID_LOOKINTEXT, .txtLabelLookIn
      
      'set captions and visibility state for template controls
      '(show only the buttons that have a caption):
      Dim sCaption, hwndButton
      'ShowWindow constants:
      Const SW_SHOWNORMAL = 1
      Const SW_HIDE = 0
      For n = 1 To 5
        sCaption = Choose(n, .txtButton1, .txtButton2, .txtButton3, .txtButton4, .txtButton5)
        hwndButton = GetDlgItem(hwnd, ID_BUTTON_OFFSET + n)
        If Len(sCaption) Then
          Call ShowWindow(hwndButton, SW_SHOWNORMAL)
          Call SetWindowText(hwndButton, sCaption)
        Else
          Call ShowWindow(hwndButton, SW_HIDE)
        End If
      Next
      
      'hide controls and their associated labels:
      If CBool(.HideControls And HideLookInListbox) Then
        HideControl ID_LOOKINTEXT, ID_LOOKINLIST
      End If
      
      If CBool(.HideControls And HideFileNameTextbox) Then
        HideControl ID_FILENAMETEXT, ID_FILENAMEEDIT
      End If
      
      If CBool(.HideControls And HideFileTypeListbox) Then
        HideControl ID_FILEOFTYPETEXT, ID_FILEOFTYPELIST
      End If
      
    End With
  Case Else: End Select

End Function

Private Sub HideControl(CTLID_1 As Long, CTLID_2 As Long)
Call SendMessage(hwndDlg, CDM_HIDECONTROL, CTLID_1, 0)
Call SendMessage(hwndDlg, CDM_HIDECONTROL, CTLID_2, 0)
End Sub

Private Sub SetCaption(CTLID As Long, sCaption As String)
If Len(sCaption) Then
   Call SendMessage(hwndDlg, CDM_SETCONTROLTEXT, CTLID, ByVal sCaption)
End If
End Sub

Private Function GetCaption(hwnd As Long) As String
Dim sBuff As String * 255, nRet
nRet = GetWindowText(hwnd, sBuff, Len(sBuff))
If nRet Then GetCaption = Left(sBuff, nRet)
End Function

Private Sub CenterChildWindow(ByVal hwndParent As Long, ByVal hwndChild As Long)
If (hwndParent = 0) Or (hwndChild = 0) Then Exit Sub
  Dim rcParent As RECT, rcChild As RECT
  Call GetWindowRect(hwndParent, rcParent)
  Call GetWindowRect(hwndChild, rcChild)
  'SWP_NOSIZE ignores the height and width:
  With rcParent
    Call SetWindowPos(hwndChild, HWND_TOP, _
      .Left + (.Right - .Left - rcChild.Right + rcChild.Left) \ 2, _
      .Top + (.Bottom - .Top - rcChild.Bottom + rcChild.Top) \ 2, _
      0, 0, SWP_NOSIZE)
  End With
End Sub

Private Sub UpdateStatusbar(nFlags, iNumPanes, _
  sFilespec, Optional sNumData As String, Optional sFileDate As String)
If hwndStatus = 0 Then Exit Sub
'Windows NT uses messages that display Unicode strings, while
'Windows 95/98 handles ANSI strings.
Dim SB_SETTEXT As Long
SB_SETTEXT = IIf(IsWinNT, SB_SETTEXTW, SB_SETTEXTA)
DestroyIcon hIconStatusbar
Call SHGetFileInfo(sFilespec, 0, SFI, Len(SFI), nFlags)
hIconStatusbar = SFI.hIcon
nPanes = Choose(iNumPanes, n1Panes, n2Panes, n3Panes) '1, 2, or 3 parts
Call PathCompactPath(hDc, sFilespec, nPanes(0))
Call SendMessage(hwndStatus, SB_SETPARTS, iNumPanes, nPanes(0))
Call SendMessage(hwndStatus, SB_SETICON, 0, ByVal hIconStatusbar)
Call SendMessage(hwndStatus, SB_SETTEXT, 0, ByVal sFilespec)
'the tab char in these msgs center the strings inside the pane:
'two tabs would right-align the strings
If Len(sNumData) Then Call SendMessage(hwndStatus, SB_SETTEXT, 1, ByVal vbTab & sNumData)
If Len(sFileDate) Then Call SendMessage(hwndStatus, SB_SETTEXT, 2, ByVal vbTab & sFileDate)
End Sub

Private Sub SetTitlebarIcon(sIconFile As String, nIconIndex As Long)
Const WM_SETICON = &H80
Const ICON_SMALL = 0
hIconCaption = ExtractIcon(0, sIconFile, nIconIndex)
If hIconCaption Then Call SendMessage(hwndDlg, WM_SETICON, ICON_SMALL, ByVal hIconCaption)
End Sub

Private Function LowWord(ByVal dw As Long) As Integer
  LowWord = dw And &HFFFF&
End Function

Private Function TranslateFileSize(s As Double) As String
Select Case s
Case Is >= MB 'use 2 decimals
  TranslateFileSize = FormatNumber(s / MB, 2) & "MB"
Case Is >= KB 'use 1 decimal if we have a fraction, otherwise none
  TranslateFileSize = FormatNumber(s / KB, Abs(CBool(s Mod KB))) & "KB"
Case Else     'don't use decimals
  TranslateFileSize = FormatNumber(s, 0) & " bytes"
End Select
End Function

Private Function TranslateFileDate(D As Date) As String
TranslateFileDate = Format(D, "SHORT DATE") & " " & Format(D, "MEDIUM TIME")
End Function

Private Sub CreateStatusbar()
Const ID_STATUS As Long = 0
Const WS_CHILD = &H40000000
Const WS_VISIBLE = &H10000000
'Create a temporary statusbar; at this point we only want to
'know its height:
hwndStatus = CreateStatusWindow(WS_CHILD Or WS_VISIBLE, _
  vbNullString, hwndDlg, ID_STATUS)
Dim rcStatus As RECT, rcDlg As RECT
Call GetWindowRect(hwndStatus, rcStatus)
Call GetWindowRect(hwndDlg, rcDlg)
'expand the dialog at the bottom to create space for the statusbar:
With rcDlg
  Call SetWindowPos(hwndDlg, HWND_TOP, 0, 0, .Right - .Left, _
     (.Bottom - .Top) + (rcStatus.Bottom - rcStatus.Top), SWP_NOMOVE)
End With

'delete the statusbar and create a new one:
DestroyWindow hwndStatus
hwndStatus = CreateStatusWindow(WS_CHILD Or WS_VISIBLE, _
  vbNullString, hwndDlg, ID_STATUS)

'create array for one statusbar part:
n1Panes(0) = -1 'stretch to end of statusbar
'create array for two statusbar parts:
n2Panes(0) = (rcStatus.Right - rcStatus.Left) * 0.78
n2Panes(1) = -1 'stretch to end of statusbar
'create array for three statusbar parts:
n3Panes(0) = (rcStatus.Right - rcStatus.Left) * 0.67
n3Panes(1) = n3Panes(0) + (rcStatus.Right - rcStatus.Left) * 0.11
n3Panes(2) = -1 'stretch to end of statusbar
hDc = GetDC(hwndStatus)
End Sub

Private Sub StretchDefaultControls()
Dim rcCtl As RECT, ptCtl As POINTAPI

Dim nDefLeft      'left margin of file name edit box
Dim nDefWidth     'width of file name edit box
Dim nLabelWidth, nLabelLeft

'get metrics of file name edit control
'its left position and width serve as criteria
Call GetWindowRect(GetDlgItem(hwndDlg, ID_FILENAMEEDIT), rcCtl)
ptCtl.x = rcCtl.Left
ptCtl.y = rcCtl.Top
ScreenToClient hwndDlg, ptCtl
nDefLeft = ptCtl.x
nDefWidth = rcCtl.Right - rcCtl.Left

'get metrics of file name label
Call GetWindowRect(GetDlgItem(hwndDlg, ID_FILENAMETEXT), rcCtl)
ptCtl.x = rcCtl.Left
ptCtl.y = rcCtl.Top
ScreenToClient hwndDlg, ptCtl
nLabelWidth = nDefLeft - ptCtl.x
nLabelLeft = ptCtl.x

With CurDialog

  If Len(.CheckBoxCaption) Then
    StretchControl ID_CHECKBOX, nDefLeft, nDefWidth
    SetCaption ID_CHECKBOX, .CheckBoxCaption
  End If
  
  If Len(.txtLabelFileName) Then
    StretchControl ID_FILENAMETEXT, nLabelLeft, nLabelWidth
    SetCaption ID_FILENAMETEXT, .txtLabelFileName
  End If
  
  If Len(.txtLabelFileType) Then
    StretchControl ID_FILEOFTYPETEXT, nLabelLeft, nLabelWidth
    SetCaption ID_FILEOFTYPETEXT, .txtLabelFileType
  End If

  If Len(.txtLabelLookIn) > Len(GetCaption(GetDlgItem(hwndDlg, _
    ID_LOOKINTEXT))) Then
    'get metrics of folder listbox
    Call GetWindowRect(GetDlgItem(hwndDlg, ID_LOOKINLIST), rcCtl)
    ptCtl.x = rcCtl.Left
    ptCtl.y = rcCtl.Top
    ScreenToClient hwndDlg, ptCtl
    
    'move and size folder listbox
    With rcCtl
      MoveWindow GetDlgItem(hwndDlg, ID_LOOKINLIST), _
        nDefLeft, ptCtl.y, (.Right - .Left + ptCtl.x - nDefLeft), (.Bottom - .Top), 0
    End With
    
    StretchControl ID_LOOKINTEXT, nLabelLeft, nLabelWidth
    
  End If
End With

End Sub

Sub StretchControl(CTLID, nLeft, nWidth)
Dim rcCtl As RECT, ptCtl As POINTAPI
Call GetWindowRect(GetDlgItem(hwndDlg, CTLID), rcCtl)
ptCtl.x = rcCtl.Left
ptCtl.y = rcCtl.Top
ScreenToClient hwndDlg, ptCtl
Call MoveWindow(GetDlgItem(hwndDlg, CTLID), _
  nLeft, ptCtl.y, nWidth, rcCtl.Bottom - rcCtl.Top, 0)
End Sub

Sub ShowMessage(sMsg, sCaption)
If Len(sMsg) Then
  Call WinMsgBox(hwndDlg, sMsg, sCaption, vbInformation Or vbOKOnly)
End If
End Sub
